//First&LastWordInFrameInColor.jsx
//InDesign CS3 JavaScript
//
//( c) Иванюшин М.Ю., 2008
// Скрипт предназаначен для окрашивания первого слова на странице
// перед запуском скрипта Do_Text_OK в режиме обработки фрагмента текста.
// Этот режим предусмотрен для случаев, когда надо привести в порядок уже сверстанный текст,
// от обработки всего текста он отличается тем, что повторяющиеся знаки перевода строки не удаляются, 
// т.к. они могли использоваться для выравнивания текста.
// Чтобы быть уверенным, что в результате обработки верстка  не поползла, можно запустить этот скрипт.
// Он красит цветом myFLWordColor первое и последнее слова в первой и последней строках каждого фрейма 
// (если там есть слова, а не просто знак перевода строки). 

if(app.documents.length != 0) { // A
var mySelection = app.selection[0];
var myDocument = app.documents.item(0);
var myColor, myName, myTextFrame;;
// myFLWordColorSample — шаблон цвета для выделения первого и последнего слов в каждом фрейме
myFLWordColorSample= [0, 100, 100, 0]; 
	if(app.selection.length != 0){ // B
	var mySelection = app.selection[0];
	myFirstRedWord(mySelection.parentStory);
	alert("Теперь запустите DO_Text_OK в режиме обработки фрагмента текста. \n");	
	exit();
	} // B
else { // C
	alert("Ничего не выбрано. \nВыберите фрейм или поместите курсор в текст и попробуйте снова.\n");	
	exit();
	} // C
} // A
alert("   Нет открытых документов.   ");	
exit();
function myFirstRedWord(myStory){ // F
   try{ //4
	 myColor = myDocument.colors.item("myFLWordColor");
	 myName = myColor.name;
    }  //4
    catch (myError) { //3
	 myColor = myDocument.colors.add ({name:"myFLWordColor", model:ColorModel.process, space:ColorSpace.CMYK, colorValue:myFLWordColorSample});
    } //3	
	
	 //цикл по числу фреймов, содержащих статью
	 for(var myCounter = 0; myCounter <  myStory.textContainers.length; myCounter ++){ // K
   	myTextFrame = myStory.textContainers[myCounter];
	if (myTextFrame.characters.length == 0) continue;
	if (myTextFrame.lines.firstItem().words.length !=0) myTextFrame.lines.firstItem().words.firstItem().fillColor = "myFLWordColor";
	if (myTextFrame.lines.lastItem().words.length !=0) myTextFrame.lines.lastItem().words.lastItem().fillColor = "myFLWordColor";
 } // K
} // F